#ifndef POZIOMICA_H
#define POZIOMICA_H

#include "settings.h"

//tego nie ruszać!
//#define HAVE_NARROW 1

#include <Arduino.h>
#include <Bounce2.h>
#include <Preferences.h>

extern void beep(int freq);
extern void say(const char *txt);
extern void saycst(const char *txt);
extern void sayfmt(const char *txt, ...);
extern void startTalkerTask(void);
extern bool isSpeaking(void);
extern void stopAudio();


extern void setSpeed(int n, bool nobeep = false);
extern void setPitch(int n, bool nobeep = false);
extern void setContrast(int n, bool nobeep = false);
extern void setGain(int n, bool nobeep = false);

extern void changeSpeed(int n);
extern void changePitch(int n);
extern void changeGain(int n);
extern void changeContrast(int n);

extern int getPitch(void);
extern int getSpeed(void);
extern int getContrast(void);
extern int getGain(void);

extern void initSpeechParams(void);
extern void storeSpeechParams(void);

extern bool getDPMode(void);
extern uint8_t getDPStrN(const char **strs);
extern void setDPMode(bool mode);
extern void setDPStr(const char *str);
extern bool getColonMode(void);
extern void setColonMode(bool mode);



extern uint8_t mainMode;
extern uint8_t subMode;
extern int crosstalk;

extern Preferences preferences;

extern void initLidar(void);
extern void lidarLoop(void);
extern int getDistance(void);
extern int setNarrowAngle(bool narrow);
extern int setLidarDistan(uint8_t distan);
extern int stopLidar(bool stopme, bool forinit=false);
extern int calibrateSPAD(void);
extern int calibrateOffset(void);
extern int calibrateCross(void);
extern int storeCalibration(void);
extern void removeLidarCalib(void);

extern void readLevel(void);
extern int getLevel(float *anglex, float *angley, float *crg = NULL);
extern void startLevCalibration(void);
extern int readLevCalibrationData(int *x, int *y, int *z);
extern void storeLevCalibDataXY(int x, int y);
extern void storeLevCalibDataZ(int z);
extern void startGyroCalibration(void);
extern int calibrateGyro(void);
extern void zeroGyro(void);
extern float getGyroZ(int z=2);

extern int8_t getBatteryStatus(int16_t *volt);
extern void readBattery(void);
extern void initBattery(void);
extern void setBattery(int milivolt);
extern void resetVolt(void);
extern int getVoltClb(int *rlv, int *adv, int *cra);

extern bool doSerialConversation(void);

#endif
