
// co drukujemy
drukuj = 7; // [0: laser tyl, 1: laser srodek, 2: laser srodek pod szklo, 3: laser przod, 4: uchwyt lasera i akcelerometru, 5: plytka przytrzymujaca akcelerometr, 6: zatyczka ochronna do lasera bez szkla z TPU, 7: złożenie]

module symetric(n=0)
{
    for (symetri3s = [0,1]) mirror([
        (n==0) ? symetri3s : 0,
        (n==1) ? symetri3s : 0,
        (n==2) ? symetri3s : 0]) children();
}
module icube(x,y,z)
{
    translate([-x/2, -y/2, 0]) cube([x,y,z]);
}

$fn=32;

module laserzatyczka()
{
    icube(12,hobud-2,1.9);
    symetric() rotate([90,0,0]) linear_extrude(8,center=true) polygon([[-2.8,0],[-2.8,4.1],[-3.8,5.1],[-3.8,6.1],[-1.6,6.1],[-1.6,0]]) ;
    
}
mpu_lo=21.2;
mpu_wo=16.4;
mpu_yholes=2.5;
mpu_xholes=15.4;

vl53_xholes=12.7;
vl53_yholes=2.5;
vl53_w=12.8;
vl53_l=17.7;
laserx=vl53_l+0.4;
    hobud=14.8;
    
echo("MH", mpu_xholes);

module dlazer(bak = 0, med=0, frt=0, glass=0)
{
    $fn=32;
    wmpx=mpu_lo+9.8;
    wlaser = laserx+4;
    //wlaser=mpu_lo+8;
    module laback()
    {
        difference() {
            union() {
                
                //translate([-wlaser/2,0,0]) cube([wlaser,hobud,2.3]);
                translate([-wmpx/2,0,0]) cube([wmpx,hobud,2.3]);
            }
            translate([-laserx/2,1.1,1.3]) cube([laserx,hobud,1.3]);
            translate([-laserx/2+1.2,1.1+10,-1]) cube([laserx-2.4,10,10]);
            symetric() translate([-vl53_xholes/2,vl53_yholes+1.5,-1]) cylinder(d=2.4,h=10);
            symetric() {
                translate([-mpu_lo/2-2,10,-1]) cylinder(d=2.4,h=10);
            }
            
            
        }
    }
    hlamed=3.5;
    module lamed() {
        translate([0,0,2.5]) difference() {
            union() {
                difference() {
                    translate([-wmpx/2,0,0]) cube([wmpx,hobud,hlamed]);
                    translate([-laserx/2,1.1,-0.1]) cube([laserx,hobud,2.3]);
                }
                symetric() translate([-vl53_xholes/2,vl53_yholes+1.5,0]) cylinder(d=4.8,h=hlamed);
                symetric() translate([laserx/2-1.2,hobud-2,0]) cube([1.3,2,hlamed]);
                
            }
            symetric() translate([-vl53_xholes/2,vl53_yholes+1.5,-1]) cylinder(d=2.4,h=10);
            if (glass) translate([-3,3,-1]) cube([6,hobud-6,10]);
               else translate([-4,2,-1]) cube([8,hobud-4,10]);
            symetric() translate([-mpu_lo/2-2,10,-1]) cylinder(d=5.6,h=10);
        }
        if (glass) translate([0,1.5+vl53_w/2,2.5+1.3]) icube(19,0.8,hlamed-1.3);
                
    }
    
    module lafrt() {
        translate([0,0,2.7+hlamed]) {
            difference() {
                union() {
                    translate([-wmpx/2,0,0]) cube([wmpx,hobud,3.1]);
                    symetric() translate([-mpu_lo/2-2,10,-hlamed+0.4]) cylinder(d=4.8,h=hlamed+1.1);
                }
                translate([-3,3,-1]) cube([6,hobud-6,10]);
                translate([-4.5,1.5,-1]) cube([9,hobud-3,1.8]);
                symetric() translate([-vl53_xholes/2,vl53_yholes+1.5,-1.6]) {
                    cylinder(d=2.4,h=10);
                    translate([0,0,3.1]) cylinder(d1=2.4, d2=4.4, h=1.61);
                }
                symetric() translate([-mpu_lo/2-2,10,-10]) cylinder(d=1.8,h=12);
            }
        }
    }
    
    if (bak) laback();
    if (med) lamed();
    if (frt) lafrt();
    
    
}

module dmpu(lo=0, hi=0)
{
    wmpx=mpu_lo+9.8;
    hlow=2.5;
    laminat=1.2;
    mpux=mpu_lo+0.4;
    mpuy=mpu_wo+0.4;
    lmpx=2+mpuy+10;
    module lom()
    {
        difference() {
            union() {
                difference() {
                    union() {
                        translate([-wmpx/2,-2,0]) cube([wmpx,lmpx,hlow+laminat]);
                        translate([-wmpx/2,lmpx-5,0]) cube([wmpx,3,hobud]);
                        translate([0,lmpx-2,hlow]) rotate([0,90,0]) linear_extrude(wmpx,center=true) polygon([[0,0],[-11,0],[0,-10]]);
                    }
                    translate([-mpux/2,0,-1]) cube([mpux, mpuy,10]);
                    translate([-laserx/2-0.4,mpuy+2,1.1]) cube([laserx+0.8,10,20]);
                    symetric() translate([-mpu_lo/2-2,lmpx-6,10]) rotate([-90,0,0]) cylinder(d=2.4,h=10);
                    symetric() translate([-mpu_lo/2-2,lmpx-10,10]) rotate([-90,0,0]) {
                        cylinder(d=4.4,h=5);
                        translate([0,0,4.99]) cylinder(d1=4.4, d2=2.4, h=1.6);
                    }
                }
                //podporki
                symetric() translate([mpux/2-3,3.5,0]) cube([4,2.4,hlow]);
                
                
                // podśrubki
                symetric() translate([mpu_xholes/2,mpuy-2.5,0]) {
                    difference() {
                        union() {
                            cylinder(d=4.8,h=hlow);
                            translate([-2.4,0,0]) cube([6,4,hlow]);
                            translate([0,-2.4,0]) cube([4,6,hlow]);
                        }
                        translate([-3,-3,hlow-1]) cube([6,1.4,10]);
                        translate([0,0,-1]) cylinder(d=2.4, h=10);
                    }
                }
            }
            symetric() translate([wmpx/2-2,1,-1]) cylinder(d=2.4,h=10);
            
        }
    }
    
    
    module him()
    {
        empx = 2+mpuy+0.4;
        translate([0,0,hlow+laminat+0.1]) difference() {
            translate([-wmpx/2,-2,0]) cube([wmpx,empx,1.5]);
            symetric() translate([mpu_xholes/2,mpuy-2.5,-1]) cylinder(d=1.8, h=10); 
            symetric() translate([wmpx/2-2,1,-1]) cylinder(d=1.8,h=10);
            translate([-mpux/2,0,-1]) cube([mpux, 5,10]);
        }
            
    }
    
    
    
    if (lo) lom();
    if (hi) him();
}

module skladanka()
{
    rotate([90,0,0]) {
        color("yellow") dlazer(1,0,0,0);
        translate([0,0,5]) color("red") dlazer(0,1,0,1);
        translate([0,0,11]) color("blue") dlazer(0,0,1,0);
    }
    mirror([0,1,0]) translate([0,-30,0]) {
        color("brown") dmpu(1,0);
        color("gray") translate([0,0,10]) dmpu(0,1);
    }
}



if (drukuj == 0) dlazer(1,0,0,0);
else if (drukuj == 1) dlazer(0,1,0,0);
else if (drukuj == 2) dlazer(0,1,0,1);
else if (drukuj == 3) dlazer(0,0,1,0);
else if (drukuj == 4) dmpu(1,0);
else if (drukuj == 5) dmpu(0,1);
else if (drukuj == 6) laserzatyczka();
else rotate([0,0,$t * 360]) skladanka();
    
    
